// EventDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PRT.h"
#include "EventDlg.h"
#include "ComputePower.h"
#include "Utilites.h"
#include "Ini.h"
#include "zip.h"
#include "unzip.h"
#include "CSmtp.h"
#include <process.h>
// CEventDlg dialog

IMPLEMENT_DYNAMIC(CEventDlg, CDialog)

CEventDlg::CEventDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEventDlg::IDD, pParent)
	, m_bClose(FALSE)
	, pMainThread(NULL)
	, m_nProgress(0)
	, m_nProcessMax(0)
{

}

CEventDlg::~CEventDlg()
{
}

void CEventDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_PROGRESS1, m_Progress1);
	DDX_Control(pDX, IDC_STATIC1, m_StaticMainMessage);
}


BEGIN_MESSAGE_MAP(CEventDlg, CDialog)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDCANCEL, &CEventDlg::OnBnClickedCancel)
END_MESSAGE_MAP()


// CEventDlg message handlers


BOOL CEventDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	//    
	::SetWindowPos(*this,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE |SWP_NOMOVE);
	//   

	m_timeGlobalTime = CTime::GetTickCount();
	SetTimer(TIMER_GLOBAL_TIMER,1000,NULL);
	
	
	//     
	pMainThread = AfxBeginThread(ThreadMainFun, this, THREAD_PRIORITY_NORMAL);
	Utilites::AddLogBegin();
	return TRUE; 

}

UINT CEventDlg::ThreadMainFun(LPVOID pVoid)
{
	CEventDlg* dlg = (CEventDlg*)(pVoid);
	//  
	dlg->pZipThread = AfxBeginThread(dlg->ThreadZipCompress, dlg, THREAD_PRIORITY_NORMAL);
	WaitForSingleObject(*(dlg->pZipThread),INFINITE);
	TRACE(_T("pZipThread end\n"));
	//   
	if (!dlg->m_bClose)
	{
		dlg->pFTPThread = AfxBeginThread(dlg->ThreadSendToFTP, dlg, THREAD_PRIORITY_NORMAL);
		WaitForSingleObject(*(dlg->pFTPThread),INFINITE);
		TRACE(_T("pFTPThread end\n"));
	}
	//   
	if (!dlg->m_bClose)
	{
		dlg->pMailThread = AfxBeginThread(dlg->ThreadSendToMail, dlg, THREAD_PRIORITY_NORMAL);
		//WaitForSingleObject(*pMailThread,INFINITE);
		while (WaitForSingleObject(*(dlg->pMailThread),1) != -1);
		TRACE(_T("pMailThread end\n"));
	}

	//  
	/*if (!dlg->m_bClose)
	{
		CWinThread *pMailThread = AfxBeginThread(dlg->ThreadSendToMail, dlg, THREAD_PRIORITY_NORMAL);
		WaitForSingleObject(*pMailThread,INFINITE);
	}*/
	//  
	if (!dlg->m_bClose)
		dlg->InitPowerOff();
	return 0;
}

UINT CEventDlg::ThreadZipCompress(LPVOID pVoid)
{
	CEventDlg* dlg = (CEventDlg*)(pVoid);

	CStringArray arrParam;
	CString str;
	//  ini
	CIni ini(Utilites::GetFilePatch()+_T("setting.ini"));
	
	//    

	if ( !ini.GetBool(_T("GLOBALS"), _T("SendMail"), FALSE)
		|| !ini.GetBool(_T("MAIL"), _T("PutZip"), FALSE))
		return 0;//   

	//   
	ini.GetKeyNames(_T("CameraImageRender"),&arrParam);

	//     Progress
	dlg->m_Progress1.SetRange(0,  arrParam.GetCount()-1);

	//    zip
	CString strFileNamezip;
	Utilites::FormatFileNameArchivePlus(strFileNamezip, 
			ini.GetString(_T("GLOBALS"), _T("localDir")));
	
	//  
	HZIP hz;

	try
	{
		hz = CreateZip(strFileNamezip,0);
		for (int i = 0; i < arrParam.GetCount(); i++)
		{
			if (dlg->m_bClose)
			{	
				CloseZip(hz);
				DeleteFile(strFileNamezip);
				Utilites::AddLogMessage(_T("Zip Canceled!!!"));
				return 0;
			}
			CString strPathFile = ini.GetString(_T("CameraImageRender"), arrParam[i]);
			CString strFileName = Utilites::ExtractFileName(strPathFile);
			strPathFile.Replace(_T("\\"), _T("\\\\"));
			str.Format(_T("Archive File\r\n%s"), strFileName);
			dlg->m_StaticMainMessage.SetWindowText(str);
			ZipAdd(hz,strFileName, strPathFile);

			dlg->m_Progress1.SetPos(i);
		}
	}
	catch (CException* /*e*/)
	{
		CloseZip(hz);
		::DeleteFile(strFileNamezip);
		Utilites::AddLogMessage(_T("Zip error!!!"));
		return 0;
	}

	CloseZip(hz);

	//       
	ini.WriteString(_T("GLOBALS"),_T("RenderArchiveName"), strFileNamezip);
	return 0;
}

UINT CEventDlg::ThreadSendToFTP(LPVOID pVoid)
{
	CEventDlg* dlg = (CEventDlg*)(pVoid);

	return 0;
}

UINT CEventDlg::ThreadSendToMail(LPVOID pVoid)
{
	CEventDlg* dlg = (CEventDlg*)(pVoid);
	BOOL bError = FALSE;
	CSmtp mail;
	CIni ini(Utilites::GetFilePatch()+_T("setting.ini"));
	try
	{

		//       
		if (!(ini.GetBool(_T("GLOBALS"), _T("SendMail"), FALSE)))
			return 0;
		Utilites::AddLogMessage(_T("Send to Mail Begin"));
		//  MAIL
		Utilites::FillMail(mail, ini);
		//     
		dlg->m_nProcessMax = Utilites::AttachFileToMail(mail, ini);
		//     
		dlg->m_Progress1.SetRange32(0, dlg->m_nProcessMax);
		mail.SetProgressAttachFile(&(dlg->m_nProgress), 
			&(dlg->m_nProcessMax),
			&(dlg->m_bClose));
		//       
		//          
		dlg->nSecondProcess = GetTickCount();
		//      
		dlg->SetTimer(TIMER_SEND_MAIL, 500, NULL);
		mail.Send();
		dlg->KillTimer(TIMER_SEND_MAIL);

	}
	catch(ECSmtp e)
	{
		Utilites::AddLogMessage(Utilites::AnsiToUnicod(e.GetErrorText().c_str()));

		bError = TRUE;
		dlg->KillTimer(TIMER_SEND_MAIL);
		//    
		CString str;
		str.Format(_T("Send to Mail\n%s"),  
			Utilites::AnsiToUnicod(e.GetErrorText().c_str()));
		dlg->m_StaticMainMessage.SetWindowText(str);
		Sleep(5000);
		// 
		return 0;
	}

	
	//    
	dlg->m_Progress1.SetPos(dlg->m_nProcessMax);
	
	//       
	dlg->m_StaticMainMessage.SetWindowText(_T("Send to Mail\nSending mail is completed!!!"));
	Utilites::AddLogMessage(_T("Send to Mail is OK"));
	Sleep(3000);
	return 0;
}

void CEventDlg::OnTimerSendMail()
{
	CString str;
	//     
	static int coutPoint = 0;
	//        
	if (m_bClose)
	{
		str.Format(_T("Send to Mail\nCanceled..."));
	}
	else if (m_nProgress == m_nProcessMax)
	{
		//  
		str.Format(_T("Send to Mail\nChecking"));
		//   n  
		for (int i = 0; i < coutPoint; i++, str +=_T('.'));
		if (++coutPoint > 6) coutPoint = 0;
	}
	else
	{
		CString st = _T("bytes");
		
		float a = (float)(m_nProgress *54) /1048576;
		float b = (float)(m_nProcessMax *54) /1048576;
		float Speed = (float)a / (GetTickCount() - nSecondProcess) *1000;
		str.Format(_T("Send to Mail\nSpeed: %0.3f Mb/sec   %.3f Mb/%.3f Mb"), Speed, a,b, st);
	}
	m_Progress1.SetPos(m_nProgress);
	m_StaticMainMessage.SetWindowText(str);
}

BOOL CEventDlg::InitPowerOff(void)
{
	//   
	CString str = Utilites::GetFilePatch()+_T("setting.ini");
	//  
	m_nEventPoverOff = GetPrivateProfileInt(_T("GLOBALS"), _T("CompPower"), 1, str);
	
	if (m_nEventPoverOff == 0)
	{
		Utilites::AddLogMessage(_T("Error: PowerOff return 0"));
		m_nEventPoverOff = 1;
	}


	//    
	switch (m_nEventPoverOff)
	{
		case 1: 
			m_strMessage = _T("Close\n %d");
			break;
		case 2: 
			m_strMessage = _T("Power Off\n %d");
			break;
		case 3: 
			m_strMessage = _T("Sleep Mode\n%d");
			break;
		case 4: 
			m_strMessage = _T("Waiting mode\n%d");
			break;
	}

	//      
	m_nCoutSecondWaitingCompPower = (GetPrivateProfileInt(_T("GLOBALS"), 
		_T("SecondWaitingCompPower"), 15, str)+1)*20;
	
	//       
	//       2  
	if (m_nEventPoverOff == 1)
		m_nCoutSecondWaitingCompPower = 1;
	
	//  
	m_Progress1.SetRange(1,m_nCoutSecondWaitingCompPower);

	//  
	str.Format(m_strMessage.GetBuffer(), m_nCoutSecondWaitingCompPower);
	GetDlgItem(IDC_STATIC1)->SetWindowText(str);

	//  
	SetTimer(TIMER_POWEROFF, 50, NULL);

	return TRUE;
}

void CEventDlg::OnTimerPowerOff(void)
{
	if (m_bClose)
		KillTimer(TIMER_POWEROFF);

	CString str;
	str.Format(m_strMessage.GetBuffer(), --m_nCoutSecondWaitingCompPower / 20);
	GetDlgItem(IDC_STATIC1)->SetWindowText(str);

	m_Progress1.SetPos(m_nCoutSecondWaitingCompPower);
	if (m_nCoutSecondWaitingCompPower <= 0)
	{
		Utilites::AddLogMessage(str);
		switch (m_nEventPoverOff)
		{
		case 2: ComputePower::PowerOff(); break;
		case 3: ComputePower::SleepPC(); break;
		case 4:ComputePower::WetingPC(); break;
		}
		KillTimer(TIMER_POWEROFF);
		m_bClose = TRUE;
		OnBnClickedCancel();
	}
}

void CEventDlg::OnTimerSGlobalTimer()
{

	CTime time(CTime::GetTickCount());
	CTimeSpan ts(m_timeGlobalTime.GetDay(),
		m_timeGlobalTime.GetHour(),
		m_timeGlobalTime.GetMinute(), 
		m_timeGlobalTime.GetSecond());
	time = (time - ts);
	this->SetWindowText(time.Format(_T("PRT - %H:%M:%S")));

}

void CEventDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	switch (nIDEvent)
	{
		case TIMER_POWEROFF:OnTimerPowerOff(); break;
		case TIMER_SEND_MAIL: OnTimerSendMail();break;
		case TIMER_GLOBAL_TIMER: OnTimerSGlobalTimer();break;
			
	}

	CDialog::OnTimer(nIDEvent);
}



void CEventDlg::OnCancel()
{
	// TODO: Add your specialized code here and/or call the base class

OnBnClickedCancel();

}


void CEventDlg::OnOK()
{
	if (m_bClose)
	{
		

		CDialog::OnOK();

	}
}


void CEventDlg::OnBnClickedCancel()
{
	m_bClose = TRUE;
	
// 	while (WaitForSingleObject(*pMainThread,1) != -1)
// 	{
// 		MSG msg;
// 		if (PeekMessage(&msg, this->GetSafeHwnd(), 0, 0, PM_REMOVE))
// 		{
// 			TranslateMessage (&msg);
// 			DispatchMessage (&msg);
// 		}
// 	}

	Utilites::AddLogEnd();
	DeleteAllResource();
	CDialog::OnCancel();
}

void CEventDlg::DeleteAllResource()
{
	CIni ini(Utilites::GetFilePatch()+_T("setting.ini"));

	//   
	DeleteFile(ini.GetString(_T("GLOBALS"),_T("RenderArchiveName")));
	//   
	ini.DeleteKey(_T("GLOBALS"),_T("RenderArchiveName"));
	
	//      
	ini.DeleteSection(_T("CameraImageRender"));
}