// InstalDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PRT.h"
#include "InstalDlg.h"
#include "Utilites.h"
#include <atlimage.h>
#include "ProgData.h"
// CInstalDlg dialog

IMPLEMENT_DYNAMIC(CInstalDlg, CDialog)

CInstalDlg::CInstalDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CInstalDlg::IDD, pParent)
{

}

CInstalDlg::~CInstalDlg()
{
}

void CInstalDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_PICTURE, m_PictureControl);
	DDX_Control(pDX, IDC_COMBO1, m_ComboBox1);
}


BEGIN_MESSAGE_MAP(CInstalDlg, CDialog)

	ON_BN_CLICKED(IDC_BUTTON_INSTALL, &CInstalDlg::OnBnClickedButtonInstall)
	ON_CBN_SELCHANGE(IDC_COMBO1, &CInstalDlg::OnCbnSelchangeCombo1)
END_MESSAGE_MAP()


// CInstalDlg message handlers



void CInstalDlg::OnBnClickedButtonInstall()
{
	CString str;
	if (Utilites::CheckRun3dMax(str))
	{
		//          
		//        
		CString strMess;
		strMess.AppendFormat(
			_T("Before installing the script to close the following programs!!!\n\n%s"),
			str);
		AfxMessageBox(strMess);

	}
	else if (m_ComboBox1.GetCurSel() == 0)
	{
		//       
		//         
		//      
		//   
		OnCbnSelchangeCombo1();
		return;
	}
	else 
	{
		//       
		//      
		try
		{
			//        
			//    
			CProgData ProgData;
			ProgData.InstallRoot(m_strListPatachMaxs[m_ComboBox1.GetCurSel()]);
		}
		catch (CErrorInstall a)
		{
			//      
			AfxMessageBox(a.GetError());

			return;
		}
		//       
		AfxMessageBox(_T("Installation Complete!!!"));

	}
}




BOOL CInstalDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	//   
	CString str;
	str.LoadString(IDS_NAME_DLG_INSTALL);
	CString name = str;
	name += _T(" ");
	str.LoadString(IDS_VERSION);
	name += str;
	SetWindowText(name);
	//  
	m_PictureControl.SetBitmap(::LoadBitmap(AfxGetApp()->m_hInstance, 
		MAKEINTRESOURCE(IDB_BITMAP1)));

	//     
	// ...        
	m_ComboBox1.AddString(_T("..."));
	m_ComboBox1.SetCurSel(m_ComboBox1.GetCount()-1);
	m_strListPatachMaxs.Add(_T("..."));

	//        
	using namespace Utilites;
	for (int i = 1; i <= MAX_LAST_VER; i++)
	{
		CString strPath;
		CString strMaxName;
		//         
		if (GetInstallMaxVersion2((MAX_VERSIONS)i, strPath, strMaxName))
		{
			//      
			// 
			
			//     
			m_ComboBox1.AddString(strMaxName);
			
			//     
			m_ComboBox1.SetCurSel(m_ComboBox1.GetCount()-1);
			
			//        
			m_strListPatachMaxs.Add(strPath);
		}
	}


	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}


void CInstalDlg::OnCbnSelchangeCombo1()
{
	//           
	if (m_ComboBox1.GetCurSel() == 0)
	{
		//    
		CString strPath;
		if (Utilites::DialogSelectFolder(this, strPath))
		{
			m_ComboBox1.AddString(strPath);
			m_ComboBox1.SetCurSel(m_ComboBox1.GetCount()-1);
			m_strListPatachMaxs.Add(strPath);
		}
	}
}


void CInstalDlg::OnCancel()
{
	// TODO: Add your specialized code here and/or call the base class

	CDialog::OnCancel();
}
