#include "StdAfx.h"
#include "ProgData.h"
#include "Utilites.h"
#include "resource.h"

CErrorInstall::CErrorInstall(CEEnum nError, CString strMess /*= _T("")*/)
{
	m_nError = nError;
	m_strMessage = strMess; 
}

CString CErrorInstall::GetError()
{

	switch(m_nError)
	{
	case ERROR_OPENDIRECTORY:
		return _T("Failed to create/open the folder\n")+m_strMessage;
	case ERROR_CREATE_FILE:
		return _T("Error in creating file\n")+m_strMessage;
	case ERROR_WRITING_FILE:
		return _T("Error writing to file\n")+m_strMessage;
	case ERROR_COPYING_FILE:
		return _T("Error copying file\n")+m_strMessage;
		
	}
	return _T("");
}

CString &CErrorInstall::GetMessage()
{
	return m_strMessage;
}
/***************************************************************************/
//   CreateCppResource
const TCHAR* CProgData::szPatchSaveFile = _T("");
/*-------------------------------------------------------------------------*/
CProgData::CProgData()
{
	strCurrentPatch = _T("C:\\");
}
/*-------------------------------------------------------------------------*/
void CProgData::CreateCppResource(CString& strFileTitle, CString &strFileExt,
						CString &strFolderPath)
{
	
	//   
	Utilites::CheckPathCherta(strFolderPath);

	CString strFilePatchName = strFolderPath+strFileTitle+_T(".")+strFileExt;
	
	//     ANSI
	CStringA strFileNameArrayA;
	strFileNameArrayA.GetBufferSetLength(MAX_PATH);
	WideCharToMultiByte(CP_ACP, 0, strFileTitle+_T("_"+strFileExt), -1, strFileNameArrayA.GetBuffer(), 
            MAX_PATH, NULL, NULL);

	CStringA strFileNameArrayA2;
	strFileNameArrayA2.GetBufferSetLength(MAX_PATH);
	WideCharToMultiByte(CP_ACP, 0, strFileTitle+_T(".")+strFileExt, -1, strFileNameArrayA2.GetBuffer(), 
            MAX_PATH, NULL, NULL);
	//        

	HANDLE hFile = ::CreateFile(strFilePatchName,
		GENERIC_READ,
		FILE_SHARE_READ,
		NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL, 0);

	if (hFile == INVALID_HANDLE_VALUE)
	{
		AfxMessageBox(_T("Open file error!!!"));
		CloseHandle(hFile);
		return;
	}
	SetFilePointer(hFile, 0, 0, FILE_BEGIN);

	//     
	DWORD CoutRead; //   
	int nCout = GetFileSize(hFile, NULL); //  
	BYTE *byteBuff = new BYTE[nCout]; //   

	//   
	ReadFile(hFile,
		(byteBuff),
		nCout,
		&CoutRead,NULL);
	CloseHandle(hFile);


	//    
	CStringA str;
	str += "#include \"StdAfx.h\"\r\n#include \"ProgData.h\"\r\n";
	
	str.AppendFormat("TCHAR* CProgData::%s_szFileName = _T(\"%s\");\r\n",
					strFileNameArrayA, strFileNameArrayA2);

	str.AppendFormat("int CProgData::%s_nSizeByte = %d;\r\n", strFileNameArrayA, nCout);

	str.AppendFormat("BYTE CProgData:: %s_pData[] = {\r\n\t", strFileNameArrayA); 
	nCout--;
	for (int i = 0; i < nCout; i++)
	{
		if (i % 20 == 0)
			str.AppendFormat("%d,\r\n\t", byteBuff[i]); //    
		else
			str.AppendFormat("%d,", byteBuff[i]);
	}

	str.AppendFormat("%d};\r\n", byteBuff[nCout]); // 

	//   
	strFilePatchName = szPatchSaveFile;
	strFilePatchName +=	_T("Resouce_")+strFileTitle+_T("_")+strFileExt+_T(".cpp");
	//     
	hFile = ::CreateFile(strFilePatchName,
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_WRITE | FILE_SHARE_READ,
		NULL, CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL, 0);
	//        
	if (hFile == INVALID_HANDLE_VALUE)
	{
		AfxMessageBox(_T("Create file error!!!"));
		CloseHandle(hFile);
		return;
	}

	WriteFile(hFile,
		(char*)(str.GetBuffer()),
		str.GetLength(),
		&CoutRead,NULL);

	//  
	CloseHandle(hFile);
	delete [] byteBuff;
}
/*-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
void CProgData::Save(CString szFileNamePatch, BYTE* pData, int nSizeByte)
{
	HANDLE hFile;
	//     
	DWORD CoutRead; //   
	if ((hFile = ::CreateFile(szFileNamePatch,
			GENERIC_READ | GENERIC_WRITE,
			FILE_SHARE_WRITE | FILE_SHARE_READ,
			NULL, CREATE_ALWAYS,
			FILE_ATTRIBUTE_NORMAL, 0)) == INVALID_HANDLE_VALUE)
	{
		throw CErrorInstall(CErrorInstall::ERROR_CREATE_FILE, szFileNamePatch); 
	}

	if (!WriteFile(hFile,
		(pData),
		nSizeByte,
		&CoutRead,NULL))
	{
		CloseHandle(hFile);
		throw CErrorInstall(CErrorInstall::ERROR_WRITING_FILE, szFileNamePatch); 
	}

	//  
	CloseHandle(hFile);
}

/*-------------------------------------------------------------------------*/
void CProgData::Save_PRT_Run_mse()
{
	Save(strCurrentPatch+PRT_Run_mse_szFileName, 
		PRT_Run_mse_pData, PRT_Run_mse_nSizeByte);
}
/*-------------------------------------------------------------------------*/
void CProgData::Save_Logs_bmp()
{
	Save(strCurrentPatch+Logs_bmp_szFileName, 
		Logs_bmp_pData, Logs_bmp_nSizeByte);
}
/*-------------------------------------------------------------------------*/
void CProgData::Save_locationData_ms(CString strRootPath)
{
	CString strT;
	strT.LoadString(IDS_INSTALL_DIRECTORY_NAME);
	strRootPath += _T("Scripts\\");
	strRootPath += strT;
	Utilites::CheckPathCherta(strRootPath);
	//      
	CStringA strFileName;
	strFileName.GetBufferSetLength(MAX_PATH);
	WideCharToMultiByte(CP_ACP, 0, strRootPath, -1, strFileName.GetBuffer(), 
		MAX_PATH, NULL, NULL);
	strFileName.Replace("\\", "\\\\");

	CStringA strByff = "(\r\n";
	strByff.AppendFormat("\tlocal strInstallPath = \"%s\"\r\n", strFileName);
	strByff +=				"\tlocal strBinPath = strInstallPath+\"bin\\\\\"\r\n"\
							"\tlocal strPRTexeFilePath = strBinPath+\"PRT.exe\""\
						"\r\n)";
	Save(strCurrentPatch+_T("locationData.ms"), (BYTE*)strByff.GetBuffer(), strByff.GetLength());
}
/*-------------------------------------------------------------------------*/
void CProgData::Save_PRT_Button_ms(CString strRootPath)
{
	CStringA p1, p2;
	p1.GetBufferSetLength(MAX_PATH);
	WideCharToMultiByte(CP_ACP, 0, strRootPath, -1, p1.GetBuffer(), 
		MAX_PATH, NULL, NULL);
	p1.Replace("\\", "\\\\");
	
	CString format_;
	format_.LoadString(IDS_INSTALL_DIRECTORY_NAME);

	p2.GetBufferSetLength(MAX_PATH);
	WideCharToMultiByte(CP_ACP, 0, format_, -1, p2.GetBuffer(), 
		MAX_PATH, NULL, NULL);

	CStringA strByff;
	strByff.Format(
	"macroScript Button_PRT category:\"PRT\" tooltip:\"PRT\" icon:#(\"PRTicon\", 1)"\
	"\r\n(\r\n"\
	"global PRTMainWindow\r\n"\
	"if PRTMainWindow == undefined or not PRTMainWindow.open do\r\n"\
	"\r\n(\r\n"\
			"sysInfo.currentdir = \"%sScripts\\\\%s\\\\\"\r\n"\
			"fileIn \"PRT_Run.mse\""\
	"\r\n)\r\n"\
	"\r\n)", p1, p2);

	Save(strCurrentPatch+_T("PRT_Button.ms"), (BYTE*)strByff.GetBuffer(), strByff.GetLength());
}
/*-------------------------------------------------------------------------*/
void CProgData::Save_PRTicon_16i_bmp()
{
	Save(strCurrentPatch+PRTicon_16i_bmp_szFileName, 
		PRTicon_16i_bmp_pData, PRTicon_16i_bmp_nSizeByte);
}
/*-------------------------------------------------------------------------*/
void CProgData::Save_PRTicon_24i_bmp()
{
	Save(strCurrentPatch+PRTicon_24i_bmp_szFileName, 
		PRTicon_24i_bmp_pData, PRTicon_24i_bmp_nSizeByte);
}

void CProgData::Save_donateWebMoney_html()
{
	Save(strCurrentPatch+donateWebMoney_html_szFileName, 
		donateWebMoney_html_pData, donateWebMoney_html_nSizeByte);
}

void CProgData::Save_donateYndex_html()
{
	Save(strCurrentPatch+donateYndex_html_szFileName, 
		donateYndex_html_pData, donateYndex_html_nSizeByte);
}

void CProgData::Save_logo_donate_png()
{
	Save(strCurrentPatch+logo_donate_png_szFileName, 
		logo_donate_png_pData, logo_donate_png_nSizeByte);
}

void CProgData::Save_paypal_bmp()
{
	Save(strCurrentPatch+paypal_bmp_szFileName, 
		paypal_bmp_pData, paypal_bmp_nSizeByte);
}

void CProgData::Save_webmoney_bmp()
{
	Save(strCurrentPatch+webmoney_bmp_szFileName, 
		webmoney_bmp_pData, webmoney_bmp_nSizeByte);
}

void CProgData::Save_yndex_bmp()
{
	Save(strCurrentPatch+yndex_bmp_szFileName, 
		yndex_bmp_pData, yndex_bmp_nSizeByte);
}

void CProgData::Save_main_css()
{
	Save(strCurrentPatch+main_css_szFileName, 
		main_css_pData, main_css_nSizeByte);
}

/*-------------------------------------------------------------------------*/
void CProgData::OpenDirectory(int nIDResource)
{
	CString str;
	str.LoadString(nIDResource);
	strCurrentPatch += str;

	if (!CreateDirectory(strCurrentPatch, NULL))
		if (GetLastError() != ERROR_ALREADY_EXISTS)
			//    
			//        
			throw CErrorInstall(CErrorInstall::ERROR_OPENDIRECTORY, strCurrentPatch);

	Utilites::CheckPathCherta(strCurrentPatch);
}
/*-------------------------------------------------------------------------*/
void CProgData::OpenDirectory(CString strPath)
{
	strCurrentPatch += strPath;

	//  
	if (!CreateDirectory(strCurrentPatch, NULL))
		if (GetLastError() != ERROR_ALREADY_EXISTS)
			//    
			//        
			throw CErrorInstall(CErrorInstall::ERROR_OPENDIRECTORY, strCurrentPatch);

	Utilites::CheckPathCherta(strCurrentPatch);
}
/*-------------------------------------------------------------------------*/
//     
void CProgData::InstallRoot(const CString strInstallRoot)
{
	try
	{
		strCurrentPatch = strInstallRoot;
		strCurrentPatch.ReleaseBuffer();

		//   Scripts\Startup
		this->OpenDirectory(_T("Scripts"));
		this->OpenDirectory(_T("Startup"));
		this->Save_PRT_Button_ms(strInstallRoot);

		//    
		strCurrentPatch = strInstallRoot;
		this->OpenDirectory(_T("ui"));
		this->OpenDirectory(_T("Icons"));
		this->Save_PRTicon_16i_bmp();
		this->Save_PRTicon_24i_bmp();

		//    
		strCurrentPatch = strInstallRoot;
		this->OpenDirectory(_T("UI_ln"));
		this->OpenDirectory(_T("IconsDark"));
		this->Save_PRTicon_16i_bmp();
		this->Save_PRTicon_24i_bmp();

		//    
		strCurrentPatch = strInstallRoot;
		this->OpenDirectory(_T("UI_ln"));
		this->OpenDirectory(_T("Icons"));
		this->Save_PRTicon_16i_bmp();
		this->Save_PRTicon_24i_bmp();

		//    
		strCurrentPatch = strInstallRoot;
		this->OpenDirectory(_T("Scripts"));
		this->OpenDirectory(IDS_INSTALL_DIRECTORY_NAME);
		this->Save_PRT_Run_mse();//  

		//   BIN
		this->OpenDirectory(IDS_BIN_DIRECTORY);//  
		this->Save_donateWebMoney_html();
		this->Save_donateYndex_html();
		this->Save_logo_donate_png();
		this->Save_paypal_bmp();
		this->Save_webmoney_bmp();
		this->Save_yndex_bmp();
		this->Save_main_css();
		this->Save_Logs_bmp();
		this->Save_locationData_ms(strInstallRoot);

		if (!Utilites::CopyFileMy(Utilites::GetFileNameExe(),  
			strCurrentPatch+_T("PRT.exe")))
			throw CErrorInstall(CErrorInstall::ERROR_WRITING_FILE, strCurrentPatch+_T("PRT.exe")); 

	}
	catch (CErrorInstall)
	{
		throw;
	}

}



