#include "StdAfx.h"
#include "Registry.h"

/*--------------------------------------------------------*/
CRegistry::CRegistry(HKEY Root)
{
	this->SetRoot(Root);


	//  Win64   
	//   64  
	if (IsWindows64())
		this->dw_Acsess = KEY_ALL_ACCESS | KEY_WOW64_64KEY;
	else
		this->dw_Acsess = KEY_ALL_ACCESS;
}

/*--------------------------------------------------------*/
CRegistry::~CRegistry(void)
{
}
/*--------------------------------------------------------*/
BOOL CRegistry::GetKeyExists(const TCHAR* szKey) const
{
	HKEY pKey;
	if (RegOpenKeyEx(h_CurKey, szKey, 0,
		dw_Acsess,
		&pKey) == ERROR_SUCCESS)
	{
		return(TRUE);
		RegCloseKey(pKey);
	}

	return(FALSE);
}
/*--------------------------------------------------------*/
BOOL CRegistry::GetValueExists(const TCHAR* szValue) const
{
	BYTE buf[MAX_PATH];
	DWORD dSize = MAX_PATH;
	if (RegQueryValueEx(h_CurKey, szValue, 
		NULL,  REG_NONE, 
		buf, &dSize) == ERROR_SUCCESS)
	{
		return(TRUE);
	}
	return(FALSE);
}
/*--------------------------------------------------------*/
int CRegistry::GetKeysCout() const
{
	int i = 0;
	DWORD NameCout;
	TCHAR buf[MAX_PATH];
	while (TRUE)
	{
		NameCout = MAX_PATH-1;
		if(RegEnumKeyEx(h_CurKey, i, buf, &NameCout,
			NULL, NULL, NULL, NULL) != ERROR_SUCCESS)
		{
			break;
		}
		i++;
	}

	return(i);
}
/*--------------------------------------------------------*/
void CRegistry::SetRoot(HKEY Root)
{
	this->h_Root = Root;
	this->h_CurKey = Root;
}
/*--------------------------------------------------------*/
REG_ERRORS CRegistry::OpenKey(const TCHAR* szKey)
{
	//    
	//      
	DWORD Disp;
	HKEY hKeyTmp;
	if (RegCreateKeyEx(h_CurKey, 
		szKey, 0, _T(""),
		REG_OPTION_NON_VOLATILE,
		dw_Acsess, NULL, &hKeyTmp, &Disp) == ERROR_SUCCESS)
	{
		h_CurKey = hKeyTmp;
		return REG_OK;
	}

	return REG_ERROR;
}
/*--------------------------------------------------------*/
void CRegistry::CloseKey()
{
	RegCloseKey(h_CurKey);
	this->h_CurKey = this->h_Root;
}
/*--------------------------------------------------------*/
REG_ERRORS CRegistry::Write_REG_SZ(const TCHAR* szName, const TCHAR* szValue) const
{
	if (RegSetValueEx(h_CurKey, szName, 
		NULL, REG_SZ, 
		(LPBYTE)szValue, 
		(DWORD)(_tcsclen(szValue)*sizeof(TCHAR))) == ERROR_SUCCESS)
	{
		return(REG_OK);
	}

	return(REG_ERROR);
}
/*--------------------------------------------------------*/
REG_ERRORS CRegistry::Read_REG_SZ(const TCHAR *szName,  TCHAR* OutBuff, 
					DWORD SizeBuff) const
{
	if (RegQueryValueEx(h_CurKey, szName, 
		NULL,  NULL, 
		(LPBYTE)OutBuff, &SizeBuff) == ERROR_SUCCESS)
	{
		return(REG_OK);
	}
	OutBuff[0] = '\0';
	return(REG_ERROR);
}
/*--------------------------------------------------------*/
BOOL CRegistry::IsWindows64() const
{
	//       
	//   IsWow64Process 
	typedef BOOL (WINAPI *LPFN_ISWOW64PROCESS) (HANDLE, PBOOL);

	LPFN_ISWOW64PROCESS fnIsWow64Process;
	BOOL bIsWow64 = FALSE;

	//      
	//    64  32

	fnIsWow64Process = (LPFN_ISWOW64PROCESS) GetProcAddress(
		GetModuleHandle(TEXT("kernel32")),"IsWow64Process");

	if(NULL != fnIsWow64Process)
	{
		if (!fnIsWow64Process(GetCurrentProcess(),&bIsWow64))
		{
			//handle error
		}
	}
	return bIsWow64;
}
/*--------------------------------------------------------*/